Summary: Change ssh_config to work best with Fermilab
Name: zz_fermi_ssh_config
Version: 1.1
Release: 3.1
License: GPL
Group: System Environment/Base
Packager: Pat Riehecky
Vendor: Fermilab
BuildArch: noarch
Requires: augeas policycoreutils coreutils gawk
Source0: ssh.aug

%description
This modifies the /etc/ssh/ssh_config file using augeas so that
your ssh connections use the FermiLab defaults. These defaults
include X11Forwarding and GSSAPI.

%prep
rm -rf $RPM_BUILD_ROOT

%install
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}/
install $RPM_SOURCE_DIR/ssh.aug $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}/

%files
%defattr(644,root,root)
%doc $RPM_SOURCE_DIR/ssh.aug

%post
# included in augeas > 9.0
if [[ ! -e /usr/share/augeas/lenses/dist/ssh.aug ]]; then
    cp -p /usr/share/doc/%name-%version/ssh.aug /usr/share/augeas/lenses/dist/
fi


%triggerin -- openssh-clients

if [ -f /etc/ssh/ssh_config ] ; then
    if ! [ -f /etc/ssh/ssh_config.save ] ; then
        /bin/cp -f /etc/ssh/ssh_config /etc/ssh/ssh_config.save
    fi

    # setup basic defaults for all SSH connections
    TMPFILE=`mktemp`
    cat > $TMPFILE <<CHANGEDEFAULT
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/Protocol 2
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/GSSAPIAuthentication yes
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/GSSAPIDelegateCredentials yes
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/GSSAPIKeyExchange yes
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/ForwardX11Trusted yes
set /files/etc/ssh/ssh_config/Host[ . = '*' ]/ForwardX11 yes

save
CHANGEDEFAULT

    # setup the default host
    augtool < $TMPFILE >/dev/null 2>&1
    rm -f $TMPFILE
    # does the FNAL host exist?
    TMPFILE=`mktemp`
    cat > $TMPFILE <<FINDHOST
match /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org' ]
FINDHOST
    FNALHOST=`augtool < $TMPFILE |grep ssh_config`
    rm -rf $TMPFILE
    if [[ "x$FNALHOST" = 'x' ]]; then
        TMPFILE=`mktemp`
        cat > $TMPFILE <<ADDHOST
ins Host before /files/etc/ssh/ssh_config/Host[ . = '*' ]
set /files/etc/ssh/ssh_config/Host[ . = '' ] '131.225.* *.fnal.gov *soudan.org'

save
ADDHOST
        # insert the new host
        augtool < $TMPFILE >/dev/null 2>&1
        rm -f $TMPFILE
    fi

    # assemble FNAL host defaults
    TMPFILE=`mktemp`
    cat > $TMPFILE <<SETOPTS
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/Protocol 2
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/GSSAPIAuthentication yes
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/GSSAPIDelegateCredentials yes
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/GSSAPIKeyExchange yes
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/ForwardX11Trusted yes
set /files/etc/ssh/ssh_config/Host[ . = '131.225.* *.fnal.gov *soudan.org']/ForwardX11 yes

save
SETOPTS

    # set the FNAL host to defaults
    augtool < $TMPFILE >/dev/null 2>&1
    rm -f $TMPFILE

    restorecon /etc/ssh/ssh_config >/dev/null 2>&1
fi


##########################################################################
%changelog
* Tue Apr 10 2012 Pat Riehecky <riehecky@fnal.gov> 1.1-3.1
- added GSSAPIKeyExchange=yes to defaults

* Fri Nov 11 2011 Pat Riehecky <riehecky@fnal.gov> 1.1-3
- switched to augeas based configuration
- added restorecon on /etc/ssh/ssh_config

* Wed Jun 22 2011 Troy Dawson <dawson@fnal.gov> 1.1-2
- fixed permission problem

* Wed Jun 22 2011 Troy Dawson <dawson@fnal.gov> 1.1-1
- Putting the changes at the beginning of the config file
- Changed the host to have 131.225.* *.fnal.gov *soudan.org

* Wed Jan 07 2009 Troy Dawson <dawson@fnal.gov> 1.0-1
- First round
